#import cProfile
import profile as myprofile
import src.pstats as pstats
import os, glob
from src.PyQMC import qmc_basic, qmc_improved

#   This file imports all truthtables found in the current
#   directory and performs QMC on it.
#   
#   Will create the performance file for each dimension.
#

def run_example(onset):
    print  "--------------------------------------------"
    primes = qmc_basic(onset)
    for x in primes.items():
        print str(x[0])+'-cubes', x[1]
 
    print  "--------------------------------------------"
    primes = qmc_improved(onset)
    for x in primes.items():
        print str(x[0])+'-cubes', x[1]


#########################################################
#
#   The exceution starts here
#
#########################################################   
truth_tables = glob.glob('*.tt')
if len(truth_tables) == 0:
    raise IOError, "Did not find any truth table files."

for filename in truth_tables:
    fh = open(filename, 'r')
    testcases = fh.readlines()
    fh.close()
    
    testcases = [line.split() for line in testcases]
    dim = len(testcases[0][0])
    for onset in testcases:
    # Perform both versions of QMC and run profiler
	myprofile.run('run_example( %s )'%str(onset),'performance%s'%dim )
        filename = 'perf%s.txt'%dim
        fh = open('perf%s.txt'%dim, 'a')
        p = pstats.Stats('performance%s'%dim, stream=fh)
        p.sort_stats('time').print_stats(100)
        fh.close()



