"""
Provides different functions needed for the QMC algorithm.
"""
import pstats, os
from BooleanOperations import resolvent, cube_distance
try:
    from sets import Set as set
    print "using sets.Set"
except:
    print "Using default set"


def qmc(implicants, method=None):
    """ Calculate prime implicants
    
        @param implicants: minterms
        @type implicants: list of strings
        @param method: switch for default or improved versions
    """
    primes = {0: implicants}
    cubedim = 0
    newcubes=[1,2,3] # only to enter while loop
    while len(newcubes) > 0:
        newcubes=[]
        covered_cubes = []
	# Get implicants of dimension cubedim
        cubes = primes[cubedim]
        for index in range(len(cubes)-1):
	    othercubes = cubes[index:]
            cube = othercubes.pop(0)

            for oc in othercubes:
                if cube_distance(cube, oc, modus='qmc') == 1:
                    newcubes.append(resolvent(cube, oc))
                    covered_cubes = covered_cubes + [oc, cube]

        primes[cubedim+1] = newcubes
        primes[cubedim] = list(set(cubes) - set(covered_cubes))
        cubedim += 1
    return primes

def qmc_improved(implicants):
    """ Perform improved version of QMC.
        
        Wrapper needed for different names in profiling
    """
    print "qmc_improved -- TODO"
    # return qmc(implicants, method='something')
    return {}
def qmc_basic(implicants):
    """ Perform basic version of QMC.
        
        Wrapper needed for different names in profiling
    """
    print "qmc_basic"
    print "dim", len(implicants[0])
    return qmc(implicants)


