
if [ $# -ne 1 ]
then
    echo -e "\n must be called with basic or improved" \n
    exit
fi

if [[ $1 == "basic" ]]
then
GNUPLOT="./simulation/show.gpl"
BASIC="./simulation/basic.dat"
PERF=`find ./simulation/ -iname 'perf*.txt'`
PERF=($PERF)
elif [[ $1 == "improved" ]]
then
    GNUPLOT="./simulation/improved.gpl"
    BASIC="./simulation/improved.dat"
    PERF=`find ./simulation/ -iname 'perf*.txt'`
    PERF=($PERF)
else
    echo "\nArgument must be basic or improved\n"
    exit
fi
#   check existance
if !([ ${#PERF[@]} -gt 0 ])
then
    echo    "No profile information found. Simulate first."
   exit 1 
fi

echo set logscale y > $GNUPLOT

# init empty file
touch $BASIC
rm $BASIC
touch $BASIC

for I in ./simulation/perf*.txt; do
    Y=${I:17:1}
    echo $Y
    grep qmc_$1 $I |  awk {'print '$Y'" " $5'} >> $BASIC

done;

echo set xrange [2 : $(expr "$Y" + 1 )] >> $GNUPLOT 
echo plot \'${BASIC}\' " title" \"$1\" >> $GNUPLOT
echo pause -1 >> $GNUPLOT 
sed -i '2 s/replot/plot/' $GNUPLOT 

if [ `cat $BASIC | sed 's,\.,,' | awk '{ SUM += $2} END { print SUM}'  ` == 0 ]
then
    echo -e "All values are zero! Logplot will fail and is skipped.\n"
    exit
fi

gnuplot $GNUPLOT
